---
name: Bug Report
about: Report gameplay issues and errors to help us improve.
title: "[Bug]:"
labels: Bug
assignees: ''

---

**Complete the template below. Reports that do not follow the template will be deleted.**
**Title should be:** [Bug]: (Short description of bug)

**Specifications**
Please provide the following.

Rimworld version:
Combat Extended version:
Combat Extended source (Steam, GitHub, etc.):
Your operating system:
Your mod list:

**Description**
Provide a concise description of the issue or concern. What happened?

**Expected behavior**
What did you expect to happen?

**To reproduce**
Provide clear steps to reproduce the behavior. How do we make this happen?

**Screenshots & log dumps**
Whenever possible, add screenshots to help explain your problem, and share error or crash logs to make our jobs easier. For logs, please enter the logs into a pastebin site (e.g pastebin.com, justpasteit.com, etc.) 
and provide a link. Do not paste the entire log here. 

**Complete the following checklist**
I hereby verify that I have done the following:
- [ ] Confirmed that my game version and load order are correct.
- [ ] Confirmed that I am running the appropriate and most updated version of Combat Extended and required compatibility patches.
- [ ] Confirmed I am not running any mods with known incompatibilities with Combat Extended.
- [ ] Disabled Combat Extended and attempted to reproduce the behavior without success.
