---
name: Patch Request
about: 'Request a new or updated Combat Extended compatibility patch for a mod. '
title: "[Patch Request]:"
labels: Patch Request
assignees: ''

---

**Read and complete the template below. Requests that fail to follow the template will be deleted without warning.**

**If a Patch Request (open or closed) already exists for the same mod, you may add a reaction to indicate your support. Do not create another request. Duplicate requests will be deleted.**

**Title should be:** [Patch Request]: (Mod Name)

**Mod name:**

**Link to mod download (preferably Steam workshop or Github):**

**Description:**
Provide a brief overview of what content the mod adds or modifies. Specify what content in particular you believe requires a patch to be compatibly with Combat Extended.

**Content:**
What does the new mod contain? Check all that apply.
- [ ] New weapons.
- [ ] New animals, humanoids, or other creatures.
- [ ] New factions.
- [ ] New armor or apparel.


**Complete the following checklist before submitting a request.**
I hereby verify that I have done all of the following:
- [ ] Searched the Steam workshop, Discord, and Github for an existing patch and not found one.
- [ ] Confirmed there are no other open Patch Requests for this mod.
- [ ] Confirmed the requested mod is not known to be fundamentally incompatible with Combat Extended.
- [ ] **Have completed this template accurately and completely.**
- [ ] **Understand that putting in a Patch Request does not guarantee a patch will be made.**
- [ ] **Agree that I will not directly contact contributors to ask about patch requests.**

**Putting in request does not guarantee a patch will be made. Do not directly contact team members about Patch Requests. For smaller mods, consider reviewing the guide and making a patch yourself. If you wish to create a patch for any requested mod, there is no need to ask for permission.**
